<?php

Class extension_markdown_guide extends Extension {
  
	// Simply outputs information to Symphony about the extension
	public function about() {
		$info = array(
			'author' => array(
				'email' => 'sassercw@cox.net',
				'name' => 'Carson Sasser',
				'website' => 'http://carsonsasser.com/'
			),
			'name' => 'Markdown Guide',
			'release-date' => '2010-04-20',
			'version' => '1.0'
		);
		return $info;
	}
	
	public function getSubscribedDelegates() {
		return array(
			array(
			'page' => '/backend/',
			'delegate' => 'ModifyTextareaFieldPublishWidget',
			'callback' => 'addGuideBelowTextArea'
			),
			array(
			'page' => '/backend/',
			'delegate' => 'InitaliseAdminPageHead',
			'callback' => 'initaliseAdminPageHead'
			)
		);
	}
	
	public function addGuideBelowTextArea($pointer) {
		//only show guide when using markdown
		$formatter = $pointer['field']->get('formatter');
		$pattern = '/^markdown/';
		if (!preg_match($pattern, $formatter)) return;

		//append the textarea here so the guide will show after the textarea in the form
		$pointer['label']->appendChild($pointer['textarea']);

		//nullify the textarea to prevent another one being appended in field.textarea.php
		$pointer['textarea'] = Widget::Label('');

		//retrieve the guide and append it
		switch($formatter){
			case 'markdown':
				$file = DOCROOT . '/extensions/markdown_guide/markdown.txt';
			break;
			case 'markdown_extra':
				$file = DOCROOT . '/extensions/markdown_guide/markdown_extra.txt';
			break;
			case 'markdown_extra_with_smartypants':
				$file = DOCROOT . '/extensions/markdown_guide/markdown_extra_with_smartypants.txt';
			break;
			case 'markdown_with_purifier':
				$file = DOCROOT . '/extensions/markdown_guide/markdown_with_purifier.txt';
			break;			
		}
		
		$contents = file_get_contents($file);
		$guide = Widget::Label($contents, null, 'markdown_guide');
		$pointer['label']->appendChild($guide);
	}

	public function initaliseAdminPageHead($context) {
		$page = $context['parent']->Page;
		
		// Include only in section edit pages
		//if ($page instanceof contentBlueprintsSections and $page->_context[0] == 'edit') {
		$page->addScriptToHead(URL . '/extensions/markdown_guide/assets/collapse_guide.js', 900200);
		//}
	}
}

?>
